# Intro

[![PyPiVersion](https://img.shields.io/pypi/v/attrsx)](https://pypi.org/project/attrsx/) [![License](https://img.shields.io/github/license/Kiril-Mordan/reusables)](https://github.com/Kiril-Mordan/reusables/blob/main/LICENSE)

**`attrsx` – A Lightweight, Playful Extension to `attrs`**  

🔧 **What is `attrsx`?**  
`attrsx` is a minimal, lightweight extension of the popular `attrs` library, designed to seamlessly add logging capabilities to your `attrs` classes.  

---

### **✨ What It Does:**  
- 🛠️ **Extends `attrs.define`** – Behaves exactly like `attrs.define`, but with automatic logger initialization.  
- 🎛️ **Built-in Logging Fields** – Adds fields for logger name, level, and format – all customizable per class or instance.  
- 🔍 **Non-Intrusive** – If you don’t need logging, `attrsx` functions just like plain old `attrs`.  

---

### **🎯 Why `attrsx`?**  
- 🚀 You sometimes just want **simple logging** without writing the same boilerplate over and over.  
- 😌 `attrsx` lets you keep things clean – adding just a little "magic" to `attrs`-based classes.  
- 🌱 It’s `attrs`, but with room for playful future extensions.  

---

### **🚧 Features at a Glance:**  
- ✅ **Fully compatible** with `attrs` 22.2.0 and later.  
- 🧩 Supports **all `attrs.define` parameters** – like `slots`, `frozen`, and more.  
- 🔧 Logger defaults to the class name but can be **overridden effortlessly**.  

---

✨ It’s `attrs`, but with just a little... **extra**. 😄


## Installation

```bash
pip install attrsx
```

